﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AutomataTim.AutomataClasses
{
    public class Automata
    {
        [NonSerialized]
        public int startId = 0;
        public List<State> States;
        public State curstate;
        public List<Connection> Connections;


        public Automata()
        {
            States = new List<State>();
            Connections = new List<Connection>();
        }

        public State AddState()
        {
            State s = new State();
            s.Coordinates = new System.Drawing.Point(0, 0);
            s.Id = ++startId;
            States.Add(s);
            return s; 
        }

        public State GetState(int Id)
        {
            return
                (from s in States
                 where s.Id == Id
                 select s).First();
        }

        public Action Step(InputData data)
        {
            Action act;
          
            Connection c = (from conn in curstate.GetConnections()
                    where conn.Data.Equals(data)
                    select conn).FirstOrDefault();

            if (c == null)
            {
                //error
            }
            else
            {
                // ok
                curstate = Framework.Automata.GetState(c.State2Id);
                return c.action;
            }

            return Action.brake;
        }
        //public Action getNextAction()

        public void DeleteState(State CurrentState)
        {
            int stateID = CurrentState.Id;
            
            var connectionsToDelete = from c in Connections
                                      where c.State1Id == stateID || c.State2Id == stateID
                                      select c;



            Connections.RemoveAll(c=>connectionsToDelete.Contains(c));
            
            States.Remove(CurrentState);
        }
    }
}
