﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.DirectX;
using System.Windows.Forms;
using System.Drawing;

namespace AutomataTim.AutomataClasses
{
    public class Car
    {
        private Vector2 position, velocity;
        float ang, speed;// temp;

        private float mspd, man, acc, brk, safe;

        private void Line(PaintEventArgs e, Vector2 p1, Vector2 p2)
        {
            System.Drawing.Pen p = System.Drawing.Pens.Blue;
            e.Graphics.DrawLine(p, (int)p1.X, (int)p1.Y, (int)p2.X, (int)p2.Y);
        }

        public Car(Vector2 pos)
        {
            mspd = 10f;
            man = 10f;
            acc = 2f;
            brk = 3f;
            safe = 50;
            position = pos;
            velocity = new Vector2(0, 0);
            ang = 1;
       //     temp = 0;
        }
        public void Paint(PaintEventArgs e)
        {
            System.Drawing.Pen p = System.Drawing.Pens.Blue;
            
            int x = (int)position.X;
            int y = (int)position.Y;

            Vector2 fv = new Vector2(10, 0);
            Vector2 lv = fv;
            fv.TransformCoordinate(Matrix.RotationZ(ang));
            lv.TransformCoordinate(Matrix.RotationZ((float)(ang + (Math.PI / 2))));

            Vector2 pt1 = fv + lv + position;
            Vector2 pt2 = fv - lv + position;
            Vector2 pt3 = -fv - lv + position;
            Vector2 pt4 = -fv + lv + position;


            Line(e, position, fv * 2 + position);
            Line(e, position, lv * 2 + position);
            Line(e, position, -lv * 2 + position);

            Line(e, pt1, pt2);
            Line(e, pt2, pt3);
            Line(e, pt3, pt4);
            Line(e, pt4, pt1);

         
            //e.Graphics.DrawRectangle(p, x1, y1, 20, 20);
        }

       /* public bool getRightWall(CarField field)
        {

            Vector2 rightdir = new Vector2(1, 0);
            rightdir.TransformCoordinate(Matrix.RotationZ((float)(ang + (Math.PI / 4))));
            return (field.getWallDistance(position, rightdir) < 60);
        }

        public bool getLeftWall(CarField field)
        {
            Vector2 leftdir = new Vector2(1, 0);
            leftdir.TransformCoordinate(Matrix.RotationZ((float)(ang - (Math.PI / 4))));
            return (field.getWallDistance(position, leftdir) < 60);
        }*/

        public int getRightWallDist(CarField field)
        {

            Vector2 rightdir = new Vector2(1, 0);
            rightdir.TransformCoordinate(Matrix.RotationZ((float)(ang + (Math.PI / 4))));
            return field.getWallDistance(position, rightdir);
        }

        public int getLeftWallDist(CarField field)
        {
            Vector2 leftdir = new Vector2(1, 0);
            leftdir.TransformCoordinate(Matrix.RotationZ((float)(ang - (Math.PI / 4))));
            return field.getWallDistance(position, leftdir);
        }

        public int getFrontDist(CarField field)
        {
            Vector2 frontdir = new Vector2(1, 0);
            frontdir.TransformCoordinate(Matrix.RotationZ((float)ang));
            return field.getWallDistance(position, frontdir);
        }

        public InputData getInputData(CarField field)
        {
            InputData id = new InputData();
            //id.leftwall = getLeftWall(field);
            //id.rightwall = getRightWall(field);
            id.leftcloser = (getLeftWallDist(field) <= getRightWallDist(field));
            id.frontclose = (getFrontDist(field) < safe);
            return id;
        }

        public void set_mspd(float _mspd)
        {
            mspd = _mspd;
        }

        public void set_acc(float _acc)
        {
            acc = _acc;
        }

        public void set_brk(float _brk)
        {
            brk = _brk;
        }

        public void set_man(float _man)
        {
            man = _man;
        }

        public void set_safe(float _safe)
        {
            safe = _safe;
        }




        public void Step(Action action, CarField field)
        {
            // some automat actions
            //temp += 0.1f;
            //ang += (float)(Math.Sin(temp)/20 +0.01);
           // velocity.X = (float)(2*Math.Cos(ang));
            //velocity.Y = (float)(2*Math.Sin(ang));
            int dist;
            if(velocity.LengthSq() > 0 && (dist=field.getWallDistance(position, velocity)) < (int)velocity.Length())
            {
               
                Vector2 nvel = velocity;
                nvel.Normalize();
                nvel *= (dist-4);
                position += nvel;
            }
            else
                position += velocity;
            //if (!field.Passable(position))
             //   position -= velocity;
            
            if (action == Action.right)
            {
                ang += (float)(Math.PI / 180 * man);
            }
            if (action == Action.left)
            {
                ang -= (float)(Math.PI / 180 * man);
            }
            if (action == Action.accelerate)
            {
                speed += acc;
                if (speed > mspd)
                    speed = mspd;
            }         
            if (action == Action.brake)
            {
                speed -=  brk;
                if (speed < 0)
                    speed = 0;
            }
            velocity.X = (float)(speed * Math.Cos((double)ang));
            velocity.Y = (float)(speed * Math.Sin((double)ang));
         /*   Vector2 normvect = velocity;
            normvect.Normalize();
            if (action == Action.accelerate)
            {
                if(velocity.Length() < 10.0)
                    velocity += normvect;
            }
            if (action == Action.brake)
            {
                if (velocity.Length() > 1.0)
                    velocity -= normvect;
                else 
                    velocity = new Vector2(0, 0);
            }
            if (action == Action.right)
            {
                velocity.TransformCoordinate(Matrix.RotationZ((float)(Math.PI / (18 + velocity.Length()))));
            }
            if (action == Action.left)
            {
                velocity.TransformCoordinate(Matrix.RotationZ((float)(-(Math.PI / (18 + velocity.Length())))));
            }*/
            ////// automata -> step(input data)
        }

    }
}
