﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using AutomataTim.AutomataClasses;
using Microsoft.DirectX;

namespace AutomataTim
{        
    public partial class CarField : Control
    {
        Bitmap field;

        Color unpassable;


        public CarField()
        {
            
            InitializeComponent();
            if(!DesignMode)
            {
                try
                {
                    field = new Bitmap("images/field.bmp");
                    unpassable = field.GetPixel(0, 0);
                }
                catch { }
            }
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
        
        }

        
       // wake up, neo
        public bool Passable(Vector2 pos)
        {
            return field.GetPixel((int)pos.X, (int)pos.Y) != unpassable;
        }

        public int getWallDistance(Vector2 position, Vector2 direction)
        {

            int px = (int)position.X;
            int py = (int)position.Y;

            if ((px <= 0) || (py <= 0) || (px >= field.Width) || (py >= field.Height))
                return 0;
            
            direction.Normalize();
            int dist = 0;
            while(field.GetPixel(px, py) !=unpassable) 
            {
                //field.SetPixel(px, py, Color.Blue);

                dist ++; 
                position += direction;
                px = (int)position.X;
                py = (int)position.Y;

                if ((px <= 0) || (py <= 0) || (px >= field.Width) || (py >= field.Height))
                    return dist;
            }
            return dist;
    
        }

       /* public bool getRightWall(Car car)
        {
            return car.getRightWall(this);
        }
        public bool getLeftWall(Car car)
        {
            return car.getRightWall(this);
        }
        */
        protected override void OnPaint(PaintEventArgs pe)
        {
            base.OnPaint(pe);

            if (!DesignMode)
            {
                pe.Graphics.DrawImage(field, 0, 0);
                Framework.car.Paint(pe);
            }
            else
            {
                // Design mode
                pe.Graphics.FillRectangle(Brushes.Red, this.ClientRectangle);
            }
            
        }
    }
}

