﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using AutomataTim.AutomataClasses;
using System.Xml.Serialization;
using System.IO;
using System.Configuration;
using Microsoft.DirectX;

namespace AutomataTim
{
    public partial class MainForm : Form
    {
       // Bitmap field;
        private string filename;

        public MainForm()
        {
            Framework.car = new Car(new Vector2(300, 120));
            // field = new Bitmap("images//field.bmp");
         
            InitializeComponent();
         //   carField1 = new CarField();
            Framework.carfield = carField2;
            
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            automataDrawer1.Automata = new Automata();
            Framework.Automata = automataDrawer1.Automata;
            /*
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(Automata));
                Stream s = new FileStream(ConfigurationManager.AppSettings["SaveFile"], FileMode.Open, FileAccess.Read);
                automataDrawer1.Automata = serializer.Deserialize(s) as Automata;
                s.Close();
                Framework.Automata = automataDrawer1.Automata;
                Framework.Automata.startId = Framework.Automata.States.Count;
                if (automataDrawer1.Automata == null)
                {
                    throw new FormatException("Неверный формат сохранённого автомата");
                }
            }
            catch
            {
                MessageBox.Show("Не удалось открыть сохранённый автомат: " + ConfigurationManager.AppSettings["SaveFile"]);
                automataDrawer1.Automata = new Automata();
                Framework.Automata = automataDrawer1.Automata;
                for (int i = 0; i < 5; i++)
                {
                    automataDrawer1.Automata.AddState();
                }
            }*/
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
         /*   if (automataDrawer1.Automata != null)
            {
                XmlSerializer serializer = new XmlSerializer(typeof(Automata));
                Stream s = new FileStream(ConfigurationManager.AppSettings["SaveFile"], FileMode.Create, FileAccess.ReadWrite);                
                serializer.Serialize(s, automataDrawer1.Automata);
                s.Close();
            }*/
        }

        private void propertyGrid1_SelectedObjectsChanged(object sender, EventArgs e)
        {
            automataDrawer1.Invalidate();
        }

        private void MainForm_Paint(object sender, PaintEventArgs e)
        {
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //Framework.Step();
            if (carField2 != null)
            {
                carField2.Refresh();
             //   Framework.carfield = carField1;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (automataDrawer1 == null || automataDrawer1.Automata == null || automataDrawer1.Automata.States.Count == 0)
                return;
            automataDrawer1.Automata.curstate = automataDrawer1.CurrentState;
            automataDrawer1.Invalidate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (automataDrawer1 == null || automataDrawer1.Automata == null || automataDrawer1.Automata.States.Count == 0 || automataDrawer1.Automata.curstate == null)
                return;
            Framework.Step();
            automataDrawer1.Invalidate();
            stepcountlabel.Text = "Steps: " + Framework.stepnum.ToString();
            stepcountlabel.Invalidate();

            if (Framework.indata.leftcloser)
                label3.Text = "Слева";
            else
                label3.Text = "Справа";
            if(Framework.indata.frontclose)
                label4.Text = "Да";
            else
                label4.Text = "Нет";


            label3.Invalidate();
            label4.Invalidate();
          //  Refresh();
        }

        private void loadAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Automata xml files (*.xml)|*.xml|All files (*.*)|*.*";
            
            
            //Если диалог отображен и нажата кнопка выбрать
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                //Имя файла и директории хранитя в войстве FileName как строка
                filename = ofd.FileName;
                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(Automata));
                    Stream s = new FileStream(filename, FileMode.Open, FileAccess.Read);
                    automataDrawer1.Automata = serializer.Deserialize(s) as Automata;
                    s.Close();
                    Framework.Automata = automataDrawer1.Automata;
                    Framework.Automata.startId = Framework.Automata.States.Count;
                    if (automataDrawer1.Automata == null)
                    {
                        throw new FormatException("Неверный формат сохранённого автомата");
                    }
                }
                catch
                {
                    MessageBox.Show("Не удалось открыть сохранённый автомат: " + filename);
                    automataDrawer1.Automata = new Automata();
                    Framework.Automata = automataDrawer1.Automata;
                }
            }

           
            Refresh();
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "Automata xml files (*.xml)|*.xml|All files (*.*)|*.*";

            
            //Если диалог отображен и нажата кнопка выбрать
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                //Имя файла и директории хранитя в войстве FileName как строка
                filename = sfd.FileName;
                if (automataDrawer1.Automata != null)
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(Automata));
                    Stream s = new FileStream(filename, FileMode.Create, FileAccess.ReadWrite);
                    serializer.Serialize(s, automataDrawer1.Automata);
                    s.Close();
                }
            }
            
            
            Refresh();
        }

        private void clearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            automataDrawer1.Automata = new Automata();
            Framework.Automata = automataDrawer1.Automata;
            Refresh();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Framework.reset();
            stepcountlabel.Text = "Steps: 0";
            stepcountlabel.Invalidate();
        }

      
        private void acc_ValueChanged(object sender, EventArgs e)
        {
            Framework.car.set_acc((float)acc.Value);
        }

        private void brk_ValueChanged(object sender, EventArgs e)
        {
            Framework.car.set_brk((float)brk.Value);
        }

        private void mspd_ValueChanged(object sender, EventArgs e)
        {
            Framework.car.set_mspd((float)mspd.Value);
        }

        private void man_ValueChanged(object sender, EventArgs e)
        {
            Framework.car.set_man((float)man.Value);
        }

        private void safe_ValueChanged(object sender, EventArgs e)
        {
            Framework.car.set_safe((float)safe.Value);
        }

      
       
    }
}
